/*
 * Copyright (c) 2017 Tilman Sauerbeck (tilman at code-monkey de)
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

pub fn write_u32(buffer: &mut [u8], _n: u32) -> usize {
    let shift = 7;
    let mask = 1 << shift;
    let mut offset = 0;
    let mut n = _n;

    while n >= mask {
        let b = (n | mask) as u8;

        buffer[offset] = b;
        offset += 1;

        n >>= shift;
    }

    buffer[offset] = n as u8;
    offset += 1;

    offset
}

pub fn write_s32(buffer: &mut [u8], n: i32) -> usize {
    let u = (n << 1) ^ (n >> 31);

    write_u32(buffer, u as u32)
}
